#ifndef __MAINWINDOW_HPP
#define __MAINWINDOW_HPP

#define TARGET_BUILD_DEBUG
#include <SophiaFramework.hpp>

// SFZWindow p
SFMTYPEDEFRESPONDER(MainWindow)
class MainWindow : public SFZWindow {
    SFMSEALRESPONDER(MainWindow)
    SFMRESPONDERINSTANTIATEFOUR(MainWindow, SFZWindow, SFYContainer, SFYWidget, SFYResponder)
public:
    // ̃X|_̃^Cv`܂B
    // ƋL݂̂Ȃ^CvSophiaFramework ɂ\񂳂Ă܂B
    enum CodeEnum {
        CODE_TYPE = four_char_code('M', 'A', 'I', 'N')
    };
    SFMTYPEDEFTYPE(CodeEnum)
private:
    SFZSingleEditBoxControlSmp      _edtYear;
    SFZSingleTextLabelControlSmp    _lblYear;
    SFZSingleEditBoxControlSmp      _edtMonth;
    SFZSingleTextLabelControlSmp    _lblMonth;
    SFZSingleEditBoxControlSmp      _edtDay;
    SFZSingleTextLabelControlSmp    _lblDay;
    SFZSingleTextLabelControlSmp    _lblPlan;       // Plan
    SFZComboBoxControlSmp           _cmbPlan;
    SFZSingleTextLabelControlSmp    _lblDetail;     // Detail
    SFZMultipleEditBoxControlSmp    _edtDetail;
    SFZSingleTextLabelControlSmp    _lblPriority;   // Priority
    SFZRadiobuttonControlSmp        _rdoHigh;
    SFZRadiobuttonControlSmp        _rdoMiddle;
    SFZRadiobuttonControlSmp        _rdoLow;
    SFZCheckboxControlSmp           _chkAlarm;      // Alarm
    SFZTextButtonControlSmp         _btnCreate;     // Create/Cancel
    SFZTextButtonControlSmp         _btnCancel;
    SFZSoftKeyControlSmp            _soft;
public:
    static MainWindowSmp NewInstance(SFCErrorPtr exception = null);
    SFCError Make(Void);
protected:
    explicit MainWindow(Void) static_throws;
    virtual ~MainWindow(Void);
private:
    SFCError CreateDate(SFXGridPtr offs);
    SFCError CreatePlan(SFXGridPtr offs);
    SFCError CreateDetail(SFXGridPtr offs);
    SFCError CreatePriority(SFXGridPtr offs);
    SFCError CreateAlarm(SFXGridPtr offs);
    SFCError CreateButtons(SFXGridPtr offs);
    SFCError MakeExitDialog(Void);
    SFCError MakeTabWindow(Void);
    SFCError MakeVersionDialog(Void);
    SFCError MakeConfigMenu(Void);
    XANDLER_DECLARE_VOIDEVENT(OnSoft)
    XANDLER_DECLARE_VOIDRESULT(OnExitDialogResult)
    XANDLER_DECLARE_VOIDRESULT(OnConfigMenuResult)
    XANDLER_DECLARE_VOIDRESULT(OnVersionDlgResult)
    XANDLER_DECLARE_VOIDEVENT(OnTabWindowSoftKey)
};

#endif // __MAINWINDOW_HPP
