#include "sfyguiapp.hpp"
#include "sfyguiapp.brh"
#include "MainWindow.hpp"
#include "Utility.hpp"
#include "CommonDef.hpp"

#define COLOR_MAINWINDOW     COLOR_LIGHT_PURPLE
#define COLOR_SOFTKEYWINDOW (SFXRGBColor(0xDD, 0xDD, 0xDD, 0x00))

// u[g [_
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    // ɃCZX R[hLq܂B
    *license = "heap://X8X2RLT6Y7UI5UFX3VEWFY0Y1S7YAX5R4YFEXQ0VKR1WLUQUIXMY1V"
        "MS5YAU8TE0PXJUPSGUAZ0YCYOS1X09ZBYFULT0VDMZ9YK4Y3VGWMUJXDTFUBRJULS8XB"
        "T4SATMV5WNS1UNWCYFWBWNWCRNVAWJTIZAMR1HWKR9WQSGYBMVBWKT7R7X8T9Z1VDTBW"
        "6TEVLWIVEUPYAW1T3XGUQU6Z9X5VIS9XDSQX5UQYETIBU6SM3R7XIXPXFU9Z0Y8UFTNY"
        "OW8U1UEWNUJUMVAYJXJS2T6SMXLV6S4RAR9YPSOVCR6WLRPDXCVLWPS7YJCRLXOUIRJE"
        "UHUHW3S9WFRGRGR9SPRGRDVDY9UO1TQYGZ4YNV9TE/";

    return (id == AEECLSID_SFYGUIAPP) ? (&sfyguiapp::Factory) : (null);
}

// t@Ng֐
SFCInvokerPtr sfyguiapp::Factory(Void)
{
    return ::new sfyguiapp;
}

// RXgN^
sfyguiapp::sfyguiapp(Void) static_throws
{
    SFCError error;

    if (static_try()) {

        // \tgL[̍쐬Ɣzu
        if ((_soft = MakeSoft(&error, GetThis())) != null) {

            // t[̎̈gщʃTCY\tgL[Rg[̃TCŸɐݒ肷
            SFXRectangle rx(GetLocalBound());
            rx.SetBottom(_soft->GetRealBound().GetTop());

            // t[̍쐬Ɣzu
            if ((_frame = MakeFrame(&error, GetThis(), rx)) != null) {

                // CEBhE̍쐬Ɣzu
                if ((_window = MakeWindow(&error, _frame)) != null) {

                    error = _soft->Bind(_window.Get(), SOFTMENU_MAIN);
                }
            }
        }
        static_throw(error);
    }
}

// fXgN^
sfyguiapp::~sfyguiapp(Void)
{
}

// \tgL[̍쐬Ɣzu
SFZSoftKeyControlSmp sfyguiapp::MakeSoft(SFCErrorPtr exception, SFYResponderSmpConstRef parent) {
    SFZSoftKeyControlSmp soft;

    // \tgL[̍쐬
    if ((soft = SFZSoftKeyControl::NewInstance(exception)) != null) {

        if ((*exception = soft->SetParent(parent)) == SFERR_NO_ERROR) {
            soft->SetRealBound(soft->GetSuitableBound(parent->GetLocalBound()));
            soft->SetBackgroundColor(COLOR_SOFTKEYWINDOW);
            soft->SetState(true, true, false, false);

            // \tgL[̓o^
            if ((*exception = soft->RegisterTextRange(IDS_SKEY_EXIT, SFXPath(SFYGUIAPP_RES_FILE), IDS_SKEY_EXIT, IDS_SKEY_DONE)) == SFERR_NO_ERROR) {

                UInt32 main[]   = {IDS_SKEY_SELECT, IDS_SKEY_EXIT, IDS_SKEY_CONFIG};
                UInt32 select[] = {IDS_SKEY_SELECT, 0, 0};
                UInt32 config[] = {IDS_SKEY_SELECT, IDS_SKEY_BACK, IDS_SKEY_DONE};

                // \tgL[j[̍쐬
                if ((*exception = soft->CreateMenu(SOFTMENU_MAIN)) == SFERR_NO_ERROR) {

                    if ((*exception = soft->SetTextKey(SOFTMENU_MAIN, main, lengthof(main))) == SFERR_NO_ERROR) {
                        if ((*exception = soft->CreateMenu(SOFTMENU_SELECT)) == SFERR_NO_ERROR) {
                            if ((*exception = soft->SetTextKey(SOFTMENU_SELECT, select, lengthof(select))) == SFERR_NO_ERROR) {
                                if ((*exception = soft->CreateMenu(SOFTMENU_CONFIG)) == SFERR_NO_ERROR) {
                                    *exception = soft->SetTextKey(SOFTMENU_CONFIG, config, lengthof(config));
                                }
                                else {
                                    soft->DestroyMenu(SOFTMENU_MAIN);
                                    soft->DestroyMenu(SOFTMENU_SELECT);
                                    soft->DestroyMenu(SOFTMENU_CONFIG);
                                }
                            }
                        }
                        else {
                            soft->DestroyMenu(SOFTMENU_MAIN);
                            soft->DestroyMenu(SOFTMENU_SELECT);
                        }
                    }
                }
                else {
                    soft->DestroyMenu(SOFTMENU_MAIN);
                }
            }
        }
    }
    if (*exception != SFERR_NO_ERROR) {
        Sanitize(static_pointer_cast<SFYResponder>(soft));
    }
    return soft;
}

// t[̍쐬Ɣzu
SFYFrameSmp sfyguiapp::MakeFrame(SFCErrorPtr exception, SFYResponderSmpConstRef parent, SFXRectangleConstRef rectangle)
{
    SFZTitlePlainFrameSmp frame;

    // t[쐬
    if ((frame = SFZTitlePlainFrame::NewInstance(exception)) != null) {
        *exception = frame->SetParent(parent);
        if (*exception == SFERR_NO_ERROR) {
            if (*exception == SFERR_NO_ERROR) {

                // t[̃^Cgݒ肷 (^Cgt[̂)
                *exception = frame->SetText("Schedule");

                if (*exception == SFERR_NO_ERROR) {
                    frame->SetRealBound(rectangle);
                    frame->SetState(true, true, true, true);
                    frame->ToFront();
                }
            }
        }
    }
    if (*exception != SFERR_NO_ERROR) {
        Sanitize(static_pointer_cast<SFYResponder>(frame));
    }
    return frame;
}

// CEBhE̍쐬Ɣzu
SFZWindowSmp sfyguiapp::MakeWindow(SFCErrorPtr exception, SFYFrameSmpConstRef frame)
{
    MainWindowSmp window;

    // CEBhE̍쐬
    if ((window = MainWindow::NewInstance(exception)) != null) {
        *exception = window->SetParent(frame);
        if (*exception == SFERR_NO_ERROR) {
            window->SetRealBound(frame->GetLocalBound().Deflate(frame->GetSuitableMargin()));
            window->SetBackgroundColor(COLOR_MAINWINDOW);
            window->SetState(true, true, true, true);
            window->Make();
        }
    }
    if (*exception != SFERR_NO_ERROR) {
        Sanitize(static_pointer_cast<SFYResponder>(window));
    }
    return window;
}
